/*
Created: 06/09/2010
*/

#pragma once
#ifndef BTCOLLISIONSHAPEGARBAGECOLLECTOR_H__
#define BTCOLLISIONSHAPEGARBAGECOLLECTOR_H__

// Just a try... needs further testing and fixing...
class btCollisionShapeGarbageCollector : public btAlignedObjectArray<btCollisionShape*> {
	public:
	typedef btAlignedObjectArray<btCollisionShape*> Base;
	typedef void (*DeleteUserPointerCallback)(class btCollisionShape& shape);
	
	btCollisionShapeGarbageCollector() : Base(), deleteUserPointerCallback(NULL) {}
	bool push_back(btCollisionShape* s,bool dontInsertDoublesAndNulls=false)	{
		if (!dontInsertDoublesAndNulls) {Base::push_back(s);return true;}
		else if (s && Find(s)==-1)  {Base::push_back(s);return true;}
		return false; 
	}
	
	~btCollisionShapeGarbageCollector()	{
		clear();
	}
	
	void clear() {
		deleteAll();		
	}
	
	// Note that in most cases: btCollisionShape::getUserPointer() is used (and cleaned) by the redering engine itself...
	void setDeleteUserPointerCallback(DeleteUserPointerCallback callback) {deleteUserPointerCallback = callback;}
	
	protected:
	
	int Find(btCollisionShape* s)	{
		const int a = Base::findLinearSearch(s);
		return (a == size()) ? -1 : a;
	}
	
	void deleteAll();
	
	void cleanList();
	
	DeleteUserPointerCallback deleteUserPointerCallback;
	
	private:
        btCollisionShapeGarbageCollector(const btCollisionShapeGarbageCollector& c) : Base() {*this=c;}
        btCollisionShapeGarbageCollector(const Base& c): Base() {*this=c;}
        const btCollisionShapeGarbageCollector& operator=(const btCollisionShapeGarbageCollector& c)	{return *this;}
        const btCollisionShapeGarbageCollector& operator=(const Base& c)	{return *this;}
        void resize(int i) {}
	void pop_back() {}
        void remove(const btCollisionShape* s) {}
	void removeDoublesAndNulls();
	void flattenHierarchy(bool dontInsertDoublesAndNulls);
	void addChildShapesOf(btCollisionShape* shape,bool dontInsertDoublesAndNulls,bool addThePassedShapeToo=false);
};


#endif //BTCOLLISIONSHAPEGARBAGECOLLECTOR_H__



